import React, { Component, useState, useEffect } from 'react';
import { Form, Icon, Input, Button, DatePicker, Select, Card, Row, Col, Pagination, Alert, Table, Avatar, Radio, Modal, Descriptions } from 'antd';
import moment from 'moment';
import EChart from '../../../../components/EchartsTest/EChart';
import request from '../../../../utils/request';
import apis from '../../../../services/apis';
import router from 'umi/router';
import BuildingSelect from '@/components/SelectButton/BuildSelect';
import AuthButton from '@/components/AuthButton';


const { RangePicker } = DatePicker;
const { Option } = Select


// const formatDate = (start, end) => {
//   const startDate = moment(start).format('YYYY-MM-DDT00:00:00.000') + 'Z'
//   const endDate = moment(end).format('YYYY-MM-DDT23:59:59.999') + 'Z'
//   return { startDate, endDate }
// }

let daterange = []
let tableTitle = ['类型']

let columns = [
  {
    title: '活动类型',
    dataIndex: 'activityType',
    key: 'activityType',
  },
  {
    title: '活动名称',
    dataIndex: 'activityName',
    key: 'activityName',
  },
  {
    title: '分享人数',
    dataIndex: 'sharePersonNum',
    key: 'sharePersonNum',
  },
  {
    title: '分享次数',
    dataIndex: 'shareNum',
    key: 'shareNum',
  },
  {
    title: '新增注册用户',
    dataIndex: 'addResigstNum',
    key: 'addResigstNum',
  },
  {
    title: '新增注册用户',
    dataIndex: 'addResigstNum',
    key: 'addResigstNum',
  },
  {
    title: '访问人数',
    dataIndex: 'visitPersonNum',
    key: 'visitPersonNum',
  },
  {
    title: '访问次数',
    dataIndex: 'visitNum',
    key: 'visitNum',
  },
  {
    title: '详情',
  },
]

class Content extends React.Component {

  constructor(props) {
    super(props)
    this.state = {
      dataSoures: [],
      tableData: [],
      userType: 'all',
      endDate: {},
      startDate: {}
    }
  }

  componentDidMount() {
    this.setState({ endDate: new Date(), startDate: moment().subtract(7, 'day').toDate() })
  }

  formatDate = (start, end) => {
    const tempStartDate = `${moment(start).format('YYYY-MM-DDT00:00:00.000')}Z`
    const tempEndDate = `${moment(end).format('YYYY-MM-DDT23:59:59.999')}Z`
    return { startDate: tempStartDate, endDate: tempEndDate }
  }

  onChangetime = (_dates, dateStrings) => {
    daterange[1] = dateStrings[1]
    daterange[0] = dateStrings[0]
  }

  handleSubmit = (e, props) => {

    e.preventDefault();

  }

  getDataOf = (days) => {
    this.setState({ endDate: new Date(), startDate: moment().subtract(days, 'day').toDate() })
  }

  datalist = () => {
    console.log()
    this.setState({ 
      endDate: daterange[1] === '' ? new Date() : daterange[1],
      startDate: daterange[0] === '' ? moment().subtract(7, 'day').toDate() : daterange[0],
    })
  }

  onSuccess = e => {
    this.setState({ dataSoures: e }, () => {
      this.onTabledatas(e)
    })
  }

  onTabledatas = (e) => {
    console.log('this.state.userType: ', this.state.userType)
    e.tdWxDicts.map(x => {
        columns = columns.filter(y => y.key != x.sceneType).concat({
          title: x.sceneAlias,
          dataIndex: x.sceneType,
          key: x.sceneType,
        })
    })
    const data = (e.list || []).reduce((acc, item) => {
      const { sceneType, fromNum, registeredNum, createTime } = item
      const num = this.state.userType === 'registered' ? registeredNum : fromNum
      acc[createTime] = { ...acc[createTime], ...item, [`${sceneType}`]: !num ? 0 : num }
      return acc
    }, {})

    const dictData =  e.tdWxDicts.reduce((acc,item,index) => {
      const { sceneType } = item
      acc[sceneType] = 0
      return acc
    },{})

    const tableData = Object.keys(data).map(k => data[k]).reduce((acc,item,index) => {
      acc[index] = { ...dictData, ...item }
      return acc
    },[])

    this.setState({ tableData })

  }

  handleSelectChange = (e) => {
    this.setState({ userType: e }, () => {
      this.onTabledatas(this.state.dataSoures)
    })
  }


  render() {
    return (
    <>
      <div style={{
        backgroundColor: '#fff',
        padding: '32PX 28px',
        boxShadow: '0px 0px 16px 2px rgba(0,0,0,0.12)',
        borderRadius: '12px',
        minHeight: '60vh'
      }}>
        <Radio.Group buttonStyle="solid" defaultValue="a">
          <Radio.Button value="c" onClick={() => this.getDataOf(1)}>最近7天</Radio.Button>
          <Radio.Button value="a" onClick={() => this.getDataOf(7)}>最近7天</Radio.Button>
          <Radio.Button value="b" onClick={() => this.getDataOf(30)}>最近1月</Radio.Button>
        </Radio.Group>
        <RangePicker
          style={{ paddingLeft: '30px', marginRight:'20px' }}
          ranges={{
            Today: [moment(), moment()],
            'This Month': [moment().startOf('month'), moment().endOf('month')],
          }}
          onChange={(_dates, dateStrings) => this.onChangetime(_dates, dateStrings)}
        />
        <BuildingSelect />
        <Select placeholder="分享类型" style={{ width: 150, marginLeft:'20px' }}>
            <Option value="activity_share">报名活动</Option>
            <Option value="help_share">助力活动</Option>
            <Option value="group_share">拼团活动</Option>
            <Option value="h5_share">H5活动</Option>
            <Option value="building_share">项目</Option>
            <Option value="news_share">资讯</Option>
        </Select>
        <Input placeholder="请输入活动名称" style={{ width: 150, marginLeft:'20px' }}></Input>
        <Button type="primary" htmlType="submit" style={{ marginLeft: '30px' }} onClick={() => this.datalist()}>
          查询
        </Button>
        <Button type="danger" onClick={() => router.go(-1)} style={{ marginBottom: '18px', marginLeft: '30px' }}>返回</Button>
        <AuthButton name="admin.customer.import" noRight={null}>
            <Button type="primary" style={{ float: 'right', margin: '20px 0', zIndex: 1 }}>
                导出
            </Button>
            </AuthButton>
        <div>
          <Table style={{marginTop:'20px'}} dataSource={this.state.tableData} columns={columns} pagination={false} scroll={{ y: 500 }}></Table>
        </div>
      </div>
    </>
    )
  }
}

export default Content
